<a id="types-aiobotocore-ssm"></a>

# types-aiobotocore-ssm

[![PyPI - types-aiobotocore-ssm](https://img.shields.io/pypi/v/types-aiobotocore-ssm.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ssm)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-ssm.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ssm)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm/)
[![PyPI - Downloads](https://static.pepy.tech/badge/types-aiobotocore-ssm)](https://pepy.tech/project/types-aiobotocore-ssm)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.SSM 2.12.3](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/ssm.html#SSM)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.23.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-ssm docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-ssm](#types-aiobotocore-ssm)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Type definitions](#type-definitions)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `SSM` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[ssm]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[ssm]'


# standalone installation
python -m pip install types-aiobotocore-ssm
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-ssm
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[ssm]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[ssm]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[ssm]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[ssm]` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[ssm]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[ssm]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SSMClient` provides annotations for `session.create_client("ssm")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ssm import SSMClient

session = get_session()
async with session.create_client("ssm") as client:
    client: SSMClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_ssm.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ssm import SSMClient
from types_aiobotocore_ssm.paginator import (
    DescribeActivationsPaginator,
    DescribeAssociationExecutionTargetsPaginator,
    DescribeAssociationExecutionsPaginator,
    DescribeAutomationExecutionsPaginator,
    DescribeAutomationStepExecutionsPaginator,
    DescribeAvailablePatchesPaginator,
    DescribeEffectiveInstanceAssociationsPaginator,
    DescribeEffectivePatchesForPatchBaselinePaginator,
    DescribeInstanceAssociationsStatusPaginator,
    DescribeInstanceInformationPaginator,
    DescribeInstancePatchStatesPaginator,
    DescribeInstancePatchStatesForPatchGroupPaginator,
    DescribeInstancePatchesPaginator,
    DescribeInventoryDeletionsPaginator,
    DescribeMaintenanceWindowExecutionTaskInvocationsPaginator,
    DescribeMaintenanceWindowExecutionTasksPaginator,
    DescribeMaintenanceWindowExecutionsPaginator,
    DescribeMaintenanceWindowSchedulePaginator,
    DescribeMaintenanceWindowTargetsPaginator,
    DescribeMaintenanceWindowTasksPaginator,
    DescribeMaintenanceWindowsPaginator,
    DescribeMaintenanceWindowsForTargetPaginator,
    DescribeOpsItemsPaginator,
    DescribeParametersPaginator,
    DescribePatchBaselinesPaginator,
    DescribePatchGroupsPaginator,
    DescribePatchPropertiesPaginator,
    DescribeSessionsPaginator,
    GetInventoryPaginator,
    GetInventorySchemaPaginator,
    GetOpsSummaryPaginator,
    GetParameterHistoryPaginator,
    GetParametersByPathPaginator,
    GetResourcePoliciesPaginator,
    ListAssociationVersionsPaginator,
    ListAssociationsPaginator,
    ListCommandInvocationsPaginator,
    ListCommandsPaginator,
    ListComplianceItemsPaginator,
    ListComplianceSummariesPaginator,
    ListDocumentVersionsPaginator,
    ListDocumentsPaginator,
    ListOpsItemEventsPaginator,
    ListOpsItemRelatedItemsPaginator,
    ListOpsMetadataPaginator,
    ListResourceComplianceSummariesPaginator,
    ListResourceDataSyncPaginator,
)

session = get_session()
async with session.create_client("ssm") as client:
    client: SSMClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    describe_activations_paginator: DescribeActivationsPaginator = client.get_paginator(
        "describe_activations"
    )
    describe_association_execution_targets_paginator: (
        DescribeAssociationExecutionTargetsPaginator
    ) = client.get_paginator("describe_association_execution_targets")
    describe_association_executions_paginator: DescribeAssociationExecutionsPaginator = (
        client.get_paginator("describe_association_executions")
    )
    describe_automation_executions_paginator: DescribeAutomationExecutionsPaginator = (
        client.get_paginator("describe_automation_executions")
    )
    describe_automation_step_executions_paginator: DescribeAutomationStepExecutionsPaginator = (
        client.get_paginator("describe_automation_step_executions")
    )
    describe_available_patches_paginator: DescribeAvailablePatchesPaginator = client.get_paginator(
        "describe_available_patches"
    )
    describe_effective_instance_associations_paginator: (
        DescribeEffectiveInstanceAssociationsPaginator
    ) = client.get_paginator("describe_effective_instance_associations")
    describe_effective_patches_for_patch_baseline_paginator: (
        DescribeEffectivePatchesForPatchBaselinePaginator
    ) = client.get_paginator("describe_effective_patches_for_patch_baseline")
    describe_instance_associations_status_paginator: DescribeInstanceAssociationsStatusPaginator = (
        client.get_paginator("describe_instance_associations_status")
    )
    describe_instance_information_paginator: DescribeInstanceInformationPaginator = (
        client.get_paginator("describe_instance_information")
    )
    describe_instance_patch_states_paginator: DescribeInstancePatchStatesPaginator = (
        client.get_paginator("describe_instance_patch_states")
    )
    describe_instance_patch_states_for_patch_group_paginator: (
        DescribeInstancePatchStatesForPatchGroupPaginator
    ) = client.get_paginator("describe_instance_patch_states_for_patch_group")
    describe_instance_patches_paginator: DescribeInstancePatchesPaginator = client.get_paginator(
        "describe_instance_patches"
    )
    describe_inventory_deletions_paginator: DescribeInventoryDeletionsPaginator = (
        client.get_paginator("describe_inventory_deletions")
    )
    describe_maintenance_window_execution_task_invocations_paginator: (
        DescribeMaintenanceWindowExecutionTaskInvocationsPaginator
    ) = client.get_paginator("describe_maintenance_window_execution_task_invocations")
    describe_maintenance_window_execution_tasks_paginator: (
        DescribeMaintenanceWindowExecutionTasksPaginator
    ) = client.get_paginator("describe_maintenance_window_execution_tasks")
    describe_maintenance_window_executions_paginator: (
        DescribeMaintenanceWindowExecutionsPaginator
    ) = client.get_paginator("describe_maintenance_window_executions")
    describe_maintenance_window_schedule_paginator: DescribeMaintenanceWindowSchedulePaginator = (
        client.get_paginator("describe_maintenance_window_schedule")
    )
    describe_maintenance_window_targets_paginator: DescribeMaintenanceWindowTargetsPaginator = (
        client.get_paginator("describe_maintenance_window_targets")
    )
    describe_maintenance_window_tasks_paginator: DescribeMaintenanceWindowTasksPaginator = (
        client.get_paginator("describe_maintenance_window_tasks")
    )
    describe_maintenance_windows_paginator: DescribeMaintenanceWindowsPaginator = (
        client.get_paginator("describe_maintenance_windows")
    )
    describe_maintenance_windows_for_target_paginator: (
        DescribeMaintenanceWindowsForTargetPaginator
    ) = client.get_paginator("describe_maintenance_windows_for_target")
    describe_ops_items_paginator: DescribeOpsItemsPaginator = client.get_paginator(
        "describe_ops_items"
    )
    describe_parameters_paginator: DescribeParametersPaginator = client.get_paginator(
        "describe_parameters"
    )
    describe_patch_baselines_paginator: DescribePatchBaselinesPaginator = client.get_paginator(
        "describe_patch_baselines"
    )
    describe_patch_groups_paginator: DescribePatchGroupsPaginator = client.get_paginator(
        "describe_patch_groups"
    )
    describe_patch_properties_paginator: DescribePatchPropertiesPaginator = client.get_paginator(
        "describe_patch_properties"
    )
    describe_sessions_paginator: DescribeSessionsPaginator = client.get_paginator(
        "describe_sessions"
    )
    get_inventory_paginator: GetInventoryPaginator = client.get_paginator("get_inventory")
    get_inventory_schema_paginator: GetInventorySchemaPaginator = client.get_paginator(
        "get_inventory_schema"
    )
    get_ops_summary_paginator: GetOpsSummaryPaginator = client.get_paginator("get_ops_summary")
    get_parameter_history_paginator: GetParameterHistoryPaginator = client.get_paginator(
        "get_parameter_history"
    )
    get_parameters_by_path_paginator: GetParametersByPathPaginator = client.get_paginator(
        "get_parameters_by_path"
    )
    get_resource_policies_paginator: GetResourcePoliciesPaginator = client.get_paginator(
        "get_resource_policies"
    )
    list_association_versions_paginator: ListAssociationVersionsPaginator = client.get_paginator(
        "list_association_versions"
    )
    list_associations_paginator: ListAssociationsPaginator = client.get_paginator(
        "list_associations"
    )
    list_command_invocations_paginator: ListCommandInvocationsPaginator = client.get_paginator(
        "list_command_invocations"
    )
    list_commands_paginator: ListCommandsPaginator = client.get_paginator("list_commands")
    list_compliance_items_paginator: ListComplianceItemsPaginator = client.get_paginator(
        "list_compliance_items"
    )
    list_compliance_summaries_paginator: ListComplianceSummariesPaginator = client.get_paginator(
        "list_compliance_summaries"
    )
    list_document_versions_paginator: ListDocumentVersionsPaginator = client.get_paginator(
        "list_document_versions"
    )
    list_documents_paginator: ListDocumentsPaginator = client.get_paginator("list_documents")
    list_ops_item_events_paginator: ListOpsItemEventsPaginator = client.get_paginator(
        "list_ops_item_events"
    )
    list_ops_item_related_items_paginator: ListOpsItemRelatedItemsPaginator = client.get_paginator(
        "list_ops_item_related_items"
    )
    list_ops_metadata_paginator: ListOpsMetadataPaginator = client.get_paginator(
        "list_ops_metadata"
    )
    list_resource_compliance_summaries_paginator: ListResourceComplianceSummariesPaginator = (
        client.get_paginator("list_resource_compliance_summaries")
    )
    list_resource_data_sync_paginator: ListResourceDataSyncPaginator = client.get_paginator(
        "list_resource_data_sync"
    )
```

<a id="waiters-annotations"></a>

### Waiters annotations

`types_aiobotocore_ssm.waiter` module contains type annotations for all
waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ssm.client import SSMClient
from types_aiobotocore_ssm.waiter import CommandExecutedWaiter

session = get_session()
async with session.create_client("ssm") as client:
    client: SSMClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    command_executed_waiter: CommandExecutedWaiter = client.get_waiter("command_executed")
```

<a id="literals"></a>

### Literals

`types_aiobotocore_ssm.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

Full list of `SSM` Literals can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm/literals/).

```python
from types_aiobotocore_ssm.literals import AssociationComplianceSeverityType


def check_value(value: AssociationComplianceSeverityType) -> bool: ...
```

<a id="type-definitions"></a>

### Type definitions

`types_aiobotocore_ssm.type_defs` module contains structures and shapes
assembled to typed dictionaries and unions for additional type checking.

Full list of `SSM` TypeDefs can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm/type_defs/).

```python
from types_aiobotocore_ssm.type_defs import AccountSharingInfoTypeDef


def get_value() -> AccountSharingInfoTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-ssm` version is the same as related `aiobotocore` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
